<?php
/**
 * Description of FunctionsWS for client
 *
 * @author Emilie Gennari
 * @created octobre 2010
 * @editor INRA-MISTEA
 * @contact anne.tireau@supagro.inra.fr, vincent.negre@supagro.inra.fr
 */
class FunctionsWS {

    var $client;
    var $wsdl;

    /*
     * Constructor : Created client php.
     */
    function FunctionsWS(){
      $this->wsdl='http://bioweb.supagro.inra.fr/phenopsis/wsdl';
      $this->client=new soapclient($this->wsdl);
    }

    /*
     * Retrieves the XML returned by getExperiments() in the web services.
     * @return XML : $xmlExperiments : return all experiments genotypes
     */
    function callGetExperiments()
    {
      $clientExperiments=$this->client->getExperiments();
      $tabExperiments=(Array)$clientExperiments;
      
      $resultExperiments=$tabExperiments["return"];
      $xmlExperiments=new SimpleXMLElement($resultExperiments);
      return $xmlExperiments;
    }

     /*
     * Display function : Display the XML retrieves by geExperiments() in the web services.
     */
    function callGetExperimentsDisplay()
    {
         $clientExperiments=$this->client->getExperiments();
         $tabExperiments=(Array)$clientExperiments;
         $Experiments=htmlentities($tabExperiments["return"]);
         echo $Experiments;
    }

    /*
     * Retrieves the XML returned by getAllGenotypes() in the web services.
     * @return XML : $xmlGenotypes : return all publics genotypes
     */
    function callGetAllGenotypes()
    {
      $clientAllGenotypes=$this->client->getAllGenotypes();
      $tabAllGenotypes=(Array)$clientAllGenotypes;
      
      $resultAllGenotypes=$tabAllGenotypes["return"];
      $xmlAllGenotypes=new SimpleXMLElement($resultAllGenotypes);
      return $xmlAllGenotypes;
    }

     /*
     * Display function : Display the XML retrieves by getAllGenotypes() in the web services.
     */
    function callGetAllGenotypesDisplay()
    {
         $clientAllGenotypes=$this->client->getAllGenotypes();
         $tabAllGenotypes=(Array)$clientAllGenotypes;
         $AllGenotypes=htmlentities($tabAllGenotypes["return"]);
         echo $AllGenotypes;
    }

     /*
     * Retrieves the XML returned by getGenotypes() in the web services.
     * @param : experiment
     * @return XML : $xmlGenotypes : return genotypes in experiment
     */
    function callGetGenotypes($experiment)
    {
      $parameters = array('experiment' => $experiment);
      $clientGenotypes=$this->client->getGenotypes($parameters);
      $tabGenotypes=(Array)$clientGenotypes;
      
      $resultGenotypes=$tabGenotypes["return"];
      $xmlGenotypes=new SimpleXMLElement($resultGenotypes);
      return $xmlGenotypes;
    }

     /*
     * Display function : Display the XML retrieves by getGenotypes() in the web services.
     */
    function callGetGenotypesDisplay($experiment)
    {
      $parameters = array('experiment' => $experiment);
      $clientGenotypes=$this->client->getGenotypes($parameters);
      $tabGenotypes=(Array)$clientGenotypes;
      $Genotypes=htmlentities($tabGenotypes["return"]);
      echo $Genotypes;
    }


    /*
     * Retrieves the XML returned by getVariables() in the web service.
     * @return XML : $xmlVariables
     */
    function callGetVariables()
    {
      $clientVariables=$this->client->getVariables();
      $tabVariables=(Array)$clientVariables;
      $resultsVariables=$tabVariables["return"];
      
      $xmlVariables=new SimpleXMLElement($resultsVariables);
      return $xmlVariables;
    }

     /*
     * Display function : Display the XML retrieves by getVariables() in the web services.
     */
    function callGetVariablesDisplay()
    {
        $clientVariables=$this->client->getVariables();
        $tabVariables=(Array)$clientVariables;
        $resultsVariables=htmlentities($tabVariables["return"]);
        echo $resultsVariables;
    }

    /*
     * Retrieves the XML returned by getImageVariables() in the web services.
     * @return XML : $xmlImagesVariables
     */
    function callGetImageVariables()
    {
        $clientImageVariables=$this->client->getImageVariables();
        $tabImageVariables=(Array)$clientImageVariables;
        $resultsImageVariables=$tabImageVariables["return"];

        $xmlImageVariables=new SimpleXMLElement($resultsImageVariables);
        return $xmlImageVariables;
    }

     /*
     * Display function : Display the XML retrieves by getImagesariables() in the web services.
     */
    function callGetImageVariablesDisplay()
    {
        $clientImageVariables=$this->client->getImageVariables();
        $tabImageVariables=(Array)$clientImageVariables;
        $resultsImageVariables=htmlentities($tabImageVariables["return"]);
        echo $resultsImageVariables;
    }
   
    /*
     * Retrieves the XML returned by getGrowthImages() in the web services.
     * @return XML : $xmlGrowthImages
     */
    function callGetGrowthImages($genotype,$experiment,$repetition)
    {
        $parameters = array('genotype' => $genotype,'experiment'=>$experiment,'repet' => $repetition);
        $clientGrowthImages=$this->client->getGrowthImages($parameters);
        $tabGrowthImages=(Array)$clientGrowthImages;
        $resultsGrowthImages=$tabGrowthImages["return"];

        //$xmlGrowthImages=new SimpleXMLElement($resultsGrowthImages);
        //return $xmlGrowthImages;
	return $resultsGrowthImages;
    }

    /*
     * Display function : Display the XML retrieves by getGrowthImages() in the web services.
     */
    function callGetGrowthImagesDisplay($genotype,$experiment,$repetition)
    {
        $parameters = array('genotype' => $genotype,'experiment'=>$experiment,'repet' => $repetition);
	$clientGrowthImages=$this->client->getGrowthImages($parameters);
        $tabGrowthImages=(Array)$clientGrowthImages;
        $resultsGrowthImages=htmlentities($tabGrowthImages["return"]);
        echo $resultsGrowthImages;
    }

    /*
     * Retrieves the XML returned by getImage() du web service.
     * $name -> in <name> <name> retrieves by getGrowthImages() or by getImages()
     * @return XML : $xmlImage -> avec code base64
     */
    function callGetImage($name)
    {
        $parameters = array('name' => $name);
        $clientImage=$this->client->getImage($parameters);
        $tabImage=(Array)$clientImage;
        $resultsImage=$tabImage["return"];

        $xmlImage=new SimpleXMLElement($resultsImage);
        return $xmlImage;
    }

     /*
     * Display function : display the image retrieve by getImage() du web service.
     * $name -> in <name> <name> retrieves by getGrowthImages() or by getImages()
     */
    function callGetImageDisplay($name)
    {

        $parameters = array('name' => $name);
        $clientImage=$this->client->getImage($parameters);
        $tabImage=(Array)$clientImage;
        $resultsImage=$tabImage["return"];

        $xmlImage=new SimpleXMLElement($resultsImage);
        $bytes64=$xmlImage->image->bytes64;

        /*Display image*/
        echo '<img src="data:image/jpg;base64,'.$bytes64.'"/>';
    }

     /*
     * Download function : Download the image retrieves by getImage() in web service
     * $urlImage : path of the image on the serveur : retrieves by getGrowthImages or getGrowthImages in <name> </name>
     *
     * $path: path to download image.
     */
    function downloadImage($urlImage,$path)
    {
        $parameters = array('name' => $urlImage);
        $clientImage=$this->client->getImage($parameters);
        $tabImage=(Array)$clientImage;
        $resultsImage=$tabImage["return"];
	
        $xmlImage=new SimpleXMLElement($resultsImage);
        $bytes64=$xmlImage->image->bytes64;
        $name=explode("/",$xmlImage->image->name);
        //echo $xmlImage->name;
        $fichier=fopen($path.$name[count($name)-1],"wb");
        fwrite($fichier,base64_decode($bytes64));
    }

    /*
     * Download function : Download images retrieves by getImages() or getGrowthImages() in web service
     * $xml : return of methods getImages() or getGrowthImages()
     *
     * $path: path to download image.
     */
     function downloadImages($xml,$path)
     {
       $xmlImage=new SimpleXMLElement($xml);
       
       foreach ($xmlImage->images->image as $image) {
	 
	 
	 $name=$image->name;
	 $parameters = array('name' => $name);
	 $clientImage=$this->client->getImage($parameters);
	 $tabImage=(Array)$clientImage;
	 $resultsImage=$tabImage["return"];
	 $xmlImage=new SimpleXMLElement($resultsImage);
	 $bytes64=$xmlImage->image->bytes64;
	 $name=explode("/",$xmlImage->image->name);
	 $fichier=fopen($path.$name[count($name)-1],"wb");
	 fwrite($fichier,base64_decode($bytes64));
	 
       }
     }

     /*
     * Retrieves the XML returned by getObservedHumidity() of web service.
     * @params : genotype ,experiment
     * @return XML
     */
     function callGetObservedHumidity($genotype,$experiment){

       $parameters = array('genotype' => $genotype,'experiment'=>$experiment);
       $clientHumidity=$this->client->getObservedHumidity($parameters);
       $tabHumidity=(Array)$clientHumidity;
       $resultsHumidity=$tabHumidity["return"];
       $xmlHumidity=new SimpleXMLElement($resultsHumidity);
       return $xmlHumidity;
     }

      /*
     * Display function : display the image retrieve by getObservedHumidity() du web service.
     * @params : genotype ,experiment
     */
     function callGetObservedHumidityDisplay($genotype,$experiment){
       
       $parameters = array('genotype' => $genotype,'experiment'=>$experiment);
       
       $clientHumidity=$this->client->getObservedHumidity($parameters);
       $tabHumidity=(Array)$clientHumidity;
       $resultsHumidity=htmlentities($tabHumidity["return"]);
       echo $resultsHumidity;
     }
}
?>
